//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop

#include "Func.h"
#include "About.cpp"
#include "GraphWnd.cpp"
#include "GraphData.h"
#include "expr.h"
#include <fstream.h>
//---------------------------------------------------------------------------
#pragma resource "*.dfm"

GraphData graph_data, *data;

void TMainForm::SetValues()
{
  Edit1 -> Text = graph_data.HorzLabel;
  Edit2 -> Text = graph_data.VertLabel;
  Edit3 -> Text = graph_data.GraphName;
  CheckBox3 -> Checked = graph_data.Marks;
  Edit4 -> Enabled = graph_data.Marks;
  UpDown1 -> Position = graph_data.HorzAmount;
  Edit5 -> Enabled = graph_data.Marks;
  UpDown2 -> Position = graph_data.VertAmount;
  CheckBox1 -> Checked = graph_data.Marks;
  Edit6 -> Enabled = graph_data.Marks & graph_data.Ticks;
  UpDown3 -> Position = graph_data.Size;
  CheckBox2 -> Checked = graph_data.Axes;
  Edit7 -> Enabled = graph_data.Axes;
  UpDown4 -> Position = graph_data.AxesWidth;
  CheckBox4 -> Checked = graph_data.Grid;
  Edit8 -> Enabled = graph_data.Grid;
  UpDown5 -> Position = graph_data.GridWidth;
  Shape1 -> Brush -> Color = graph_data.GraphColor;
  Shape2 -> Brush -> Color = graph_data.BackColor;
  Shape3 -> Brush -> Color = graph_data.AxesColor;
  Shape4 -> Brush -> Color = graph_data.MarksColor;
  Shape5 -> Brush -> Color = graph_data.TicksColor;
  Shape6 -> Brush -> Color = graph_data.GridColor;
  Edit9 -> Text = graph_data.Expr;
  Edit10 -> Text = FloatToStrF(graph_data.From, 0, 8, 8);
  Edit11 -> Text = FloatToStrF(graph_data.To, 0, 8, 8);
}

TMainForm *MainForm;
//---------------------------------------------------------------------------
__fastcall TMainForm::TMainForm(TComponent* Owner)
	: TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::CheckBox3Click(TObject *Sender)
{
  graph_data.Marks = CheckBox3 -> Checked;
  if (CheckBox3 -> Checked)
  {
    UpDown1 -> Enabled = true;
    UpDown2 -> Enabled = true;
    Edit4 -> Enabled = true;
    Edit5 -> Enabled = true;
    if (CheckBox1 -> Checked)
    {
      Edit6 -> Enabled = true;
      UpDown3 -> Enabled = true;
    }
    CheckBox1 -> Enabled = true;
  }
  else
  {
    UpDown1 -> Enabled = false;
    UpDown2 -> Enabled = false;
    UpDown3 -> Enabled = false;
    Edit4 -> Enabled = false;
    Edit5 -> Enabled = false;
    Edit6 -> Enabled = false;
    CheckBox1 -> Enabled = false;
  }
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::CheckBox1Click(TObject *Sender)
{
  graph_data.Ticks = CheckBox1 -> Checked;
  if (CheckBox1 ->	Checked)
  {
    Edit6 -> Enabled = true;
    UpDown3 -> Enabled = true;
  }
  else
  {
    Edit6 -> Enabled = false;
    UpDown3 -> Enabled = false;
  }
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::CheckBox2Click(TObject *Sender)
{
  graph_data.Axes = CheckBox2 -> Checked;
  if (CheckBox2 -> Checked)
  {
    Edit7 -> Enabled = true;
    UpDown4 -> Enabled = true;
  }
  else
  {
    Edit7 -> Enabled = false;
    UpDown4 -> Enabled = false;
  }
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::CheckBox4Click(TObject *Sender)
{
  graph_data.Grid = CheckBox4 -> Checked;
  if (CheckBox4 -> Checked)
  {
    Edit8 -> Enabled = true;
    UpDown5 -> Enabled = true;
  }
  else
  {
    Edit8 -> Enabled = false;
    UpDown5 -> Enabled = false;
  }
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::FormCreate(TObject *Sender)
{
  Left = 0;
  Top = 0;
  graph_data.HorzLabel = "X";
  graph_data.VertLabel = "Y";
  graph_data.GraphName = "Graph";
  graph_data.Marks = true;
  graph_data.HorzAmount = 5;
  graph_data.VertAmount = 5;
  graph_data.Ticks = true;
  graph_data.Size = 1;
  graph_data.Axes = true;
  graph_data.AxesWidth = 1;
  graph_data.Grid = false;
  graph_data.GridWidth = 1;
  graph_data.GraphColor = clBlack;
  graph_data.BackColor = clWhite;
  graph_data.AxesColor = clBlack;
  graph_data.MarksColor = clBlack;
  graph_data.TicksColor = clBlack;
  graph_data.GridColor = clBlack;
  graph_data.Expr = "x";
  graph_data.From = 0.0;
  graph_data.To = 1.0;
  SetValues();
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::Edit1Change(TObject *Sender)
{
  graph_data.HorzLabel = Edit1 -> Text;
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::Edit2Change(TObject *Sender)
{
  graph_data.VertLabel = Edit2 -> Text;
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::Edit3Change(TObject *Sender)
{
  graph_data.GraphName = Edit3 -> Text;
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::UpDown1Click(TObject *Sender, TUDBtnType Button)
{
  graph_data.HorzAmount = UpDown1 -> Position;
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::UpDown2Click(TObject *Sender, TUDBtnType Button)
{
  graph_data.VertAmount = UpDown2 -> Position;
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::UpDown3Click(TObject *Sender, TUDBtnType Button)
{
  graph_data.Size = UpDown3 -> Position;
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::UpDown4Click(TObject *Sender, TUDBtnType Button)
{
  graph_data.AxesWidth = UpDown4 -> Position;
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::UpDown5Click(TObject *Sender, TUDBtnType Button)
{
  graph_data.GridWidth = UpDown5 -> Position;
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::Edit9Change(TObject *Sender)
{
  graph_data.Expr = Edit9 -> Text;
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::Button1Click(TObject *Sender)
{
  ColorDialog1 -> Color = graph_data.GraphColor;
  if (ColorDialog1 -> Execute())
  {
    graph_data.GraphColor = ColorDialog1 -> Color;
    Shape1 -> Brush -> Color = ColorDialog1 -> Color;
  }
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::Button2Click(TObject *Sender)
{
  ColorDialog1 -> Color = graph_data.BackColor;
  if (ColorDialog1 -> Execute())
  {
    graph_data.BackColor = ColorDialog1 -> Color;
    Shape2 -> Brush -> Color = ColorDialog1 -> Color;
  }
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::Button3Click(TObject *Sender)
{
  ColorDialog1 -> Color = graph_data.AxesColor;
  if (ColorDialog1 -> Execute())
  {
    graph_data.AxesColor = ColorDialog1 -> Color;
    Shape3 -> Brush -> Color = ColorDialog1 -> Color;
  }
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::Button4Click(TObject *Sender)
{
  ColorDialog1 -> Color = graph_data.MarksColor;
  if (ColorDialog1 -> Execute())
  {
    graph_data.MarksColor = ColorDialog1 -> Color;
    Shape4 -> Brush -> Color = ColorDialog1 -> Color;
  }
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::Button5Click(TObject *Sender)
{
  ColorDialog1 -> Color = graph_data.TicksColor;
  if (ColorDialog1 -> Execute())
  {
    graph_data.TicksColor = ColorDialog1 -> Color;
    Shape5 -> Brush -> Color = ColorDialog1 -> Color;
  }
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::Button6Click(TObject *Sender)
{
  ColorDialog1 -> Color = graph_data.GridColor;
  if (ColorDialog1 -> Execute())
  {
    graph_data.GridColor = ColorDialog1 -> Color;
    Shape6 -> Brush -> Color = ColorDialog1 -> Color;
  }
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::Button8Click(TObject *Sender)
{
  Close();
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::Button9Click(TObject *Sender)
{
  AboutBox -> ShowModal();	
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::Edit10Change(TObject *Sender)
{
  try
  {
    graph_data.From = Edit10 -> Text.ToDouble();
  }
  catch (Exception *e)
  {
    Edit10 -> Text = FloatToStrF(graph_data.From, 0, 8, 8);
  }
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::Edit11Change(TObject *Sender)
{
  try
  {
    graph_data.To = Edit11 -> Text.ToDouble();
  }
  catch (Exception *e)
  {
    Edit11 -> Text = FloatToStrF(graph_data.To, 0, 8, 8);
  }
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::Button7Click(TObject *Sender)
{
  char s[128];

  if (Edit9 -> Text == "")
  {
    Application -> MessageBox(" ", "", MB_OK | MB_ICONSTOP);
    return;
  }

  try
  {
    delete graph_data.s;
    graph_data.s = new StringExpr(Edit9 -> Text.c_str());
  }
  catch (ExprException *e)
  {
    e -> GetMessage(s);
    Application -> MessageBox(s, "  ", MB_OK | MB_ICONSTOP);
    return;
  }
  delete data;
  data = new GraphData(graph_data);
  GraphWindow -> Show();
  GraphWindow -> Redraw(data);
  GraphWindow -> Invalidate();
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::Button10Click(TObject *Sender)
{
  AnsiString filename;
  if (SaveDialog1 -> Execute())
  {
    filename = SaveDialog1 -> FileName;
    Save(filename);
  }
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::Button11Click(TObject *Sender)
{
  AnsiString filename;
  if (OpenDialog1 -> Execute())
  {
    filename = OpenDialog1 -> FileName;
    Load(filename);
  }
}

void TMainForm::Save(AnsiString filename)
{
  char *s;
  int l;
  ofstream out(filename.c_str(), ios::binary);

  if (!out)
  {
    Application -> MessageBox("  ", "", MB_OK | MB_ICONSTOP);
    return;
  }

  s = graph_data.HorzLabel.c_str();
  l = strlen(s);
  out.write((char *)&l, sizeof(l));
  out.write(s, l + 1);

  s = graph_data.VertLabel.c_str();
  l = strlen(s);
  out.write((char *)&l, sizeof(l));
  out.write(s, l + 1);

  s = graph_data.GraphName.c_str();
  l = strlen(s);
  out.write((char *)&l, sizeof(l));
  out.write(s, l + 1);

  out.write((char *)&graph_data.Marks,
            (char *)&(graph_data.Expr) - (char *)&(graph_data.Marks));

  s = graph_data.Expr.c_str();
  l = strlen(s);
  out.write((char *)&l, sizeof(l));
  out.write(s, l + 1);

  out.write((char *)&graph_data.From, sizeof(double) * 2);

  out.close();
}

void TMainForm::Load(AnsiString filename)
{
  char s[129];
  int l;
  ifstream in(filename.c_str(), ios::binary);

  if (!in)
  {
    Application -> MessageBox("  ", "", MB_OK | MB_ICONSTOP);
    return;
  }

  in.read((char *)&l, sizeof(l));
  in.read(s, l + 1);
  graph_data.HorzLabel = AnsiString(s);

  in.read((char *)&l, sizeof(l));
  in.read(s, l + 1);
  graph_data.VertLabel = AnsiString(s);

  in.read((char *)&l, sizeof(l));
  in.read(s, l + 1);
  graph_data.GraphName = AnsiString(s);

  in.read((char *)&graph_data.Marks,
          (char *)&(graph_data.Expr) - (char *)&(graph_data.Marks));

  in.read((char *)&l, sizeof(l));
  in.read(s, l + 1);
  graph_data.Expr = AnsiString(s);

  in.read((char *)&graph_data.From, sizeof(double) * 2);

  in.close();
  SetValues();
}

//---------------------------------------------------------------------------
