//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop

#include "GraphWnd.h"
#include "SetSize.cpp"
#include "Expr.h"
//---------------------------------------------------------------------------
#pragma resource "*.dfm"
TGraphWindow *GraphWindow;
GraphData *prev_data = NULL;
TImage *image;

void TGraphWindow::Redraw(GraphData *data)
{
  prev_data = data;
  double *values, Max, Min;
  int w = ClientWidth;
  int h = ClientHeight;
  int w2, h2, x2, y2;
  int *ticks_x = new int[data -> HorzAmount];
  int *ticks_y = new int[data -> VertAmount];
  int a;
  delete image;
  image = new TImage(this);
  image -> SetBounds(0, 0, ClientWidth, ClientHeight);
  TCanvas *c = image -> Canvas;
  c -> Brush -> Color = data -> BackColor;
  c -> Pen -> Color = data -> BackColor;
  c -> Rectangle(0, 0, w, h);
  c -> Font -> Name = "Times New Roman Cyr";
  c -> Font -> Size = 14;
  c -> Font -> Color = data -> AxesColor;
  if (data -> Marks)
    x2 = 50;
  else
    x2 = 20;
  if (data -> Marks)
    h2 = -40;
  else
    h2 = -20;
  w2 = w - x2 - c -> TextWidth(data -> HorzLabel) - 40;
  c -> TextOut(x2 + (w2 - c -> TextWidth(data -> GraphName)) / 2, 8, data -> GraphName);
  y2 = 60;
  h2 += h - y2;
  c -> Font -> Size = 10;
  if (data -> Axes)
  {
    c -> Pen -> Color = data -> AxesColor;
    c -> Pen -> Width = data -> AxesWidth;
    c -> MoveTo(x2, y2);
    c -> LineTo(x2, y2 + h2);
    c -> LineTo(x2 + w2, y2 + h2);
    if (!data -> Grid)
    {
      c -> MoveTo(x2, y2);
      c -> LineTo(x2 - 2, y2 + 10);
      c -> MoveTo(x2, y2);
      c -> LineTo(x2 + 2, y2 + 10);
      c -> MoveTo(x2 + w2, y2 + h2);
      c -> LineTo(x2 + w2 - 10, y2 + h2 + 2);
      c -> MoveTo(x2 + w2, y2 + h2);
      c -> LineTo(x2 + w2 - 10, y2 + h2 - 2);
    }
  }
  if (data -> Axes)
  {
    c -> TextOut(x2 + 10, y2 - 20, data -> VertLabel);
    c -> TextOut(x2 + w2 + 10, y2 + h2, data -> HorzLabel);
  }
  int y = y2 + h2 - data -> Size - data -> AxesWidth / 2;
  int x = x2 - data -> Size - data -> AxesWidth / 2;
  c -> Font -> Size = 8;
  Max = -1.7e+308;
  Min = 1.7e+308;
  if (!data -> Grid)
    values = new double[w2 - 30 + 1];
  else
    values = new double[w2 + 1];
  a = (data -> Grid) ? 0 : 30;
  for (int i = 0; i <= w2 - a; i++)
  {
    try
    {
      values[i] = data -> s -> GetValue(data -> From + i * (data -> To - data -> From) / (w2 - a));
    }
    catch (ExprException *e)
    {
      char s[128];
      e -> GetMessage(s);
      Application -> MessageBox(s, "", MB_OK | MB_ICONSTOP);
      Close();
      return;
    }
    if (values[i] > Max) Max = values[i];
    if (values[i] < Min) Min = values[i];
  }
  if (Min == Max)
  {
    if (!Max) Max = 1;
    Min = 0;
  }
  if (data -> Marks || data -> Grid)
  {
    AnsiString s;
    c -> Pen -> Color = data -> TicksColor;
    c -> Pen -> Width = 1;
    double step;
    if (data -> HorzAmount < 2)
      step = 0;
    else
      step = double(w2 - 50) / (data -> HorzAmount - 1);
    for (int i = 0; i < data -> HorzAmount; i++)
    {
      int x;
      if (data -> HorzAmount < 2)
        x = (w2 - 50) / 2 + x2 + 20;
      else
        x = x2 + 20 + i * step;
      int h = data -> Size * 2 + data -> AxesWidth;
      ticks_x[i] = x;
      if (data -> Marks)
      {
        s = FloatToStrF(data -> From + (x - x2) * (data -> To - data -> From) / (w2 - a), 0, 3, 8);
        c -> TextOut(x - (c -> TextWidth(s) / 2), y2 + h2 + data -> Size + 5, s);
        if (data -> Ticks)
        {
          c -> MoveTo(x, y);
          c -> LineTo(x, y + h);
        }
      }
      if (data -> Grid && data -> Ticks)
      {
        c -> MoveTo(x, y - h2);
        c -> LineTo(x, y + h - h2);
      }
    }
    if (data -> VertAmount < 2)
      step = 0;
    else
      step = double(h2 - 50) / (data -> VertAmount - 1);
    for (int i = 0; i < data -> VertAmount; i++)
    {
      int y;
      if (data -> VertAmount < 2)
        y = (h2 - 50) / 2 + y2 + 30;
      else
        y = y2 + 30 + i * step;
      int h = data -> Size * 2 + data -> AxesWidth;
      ticks_y[i] = y;
      if (data -> Marks)
      {
        if (!data -> Grid)
          s = FloatToStrF(double(y2 + h2 - y) / (h2 - 30) * (Max - Min) + Min, 0, 3, 8);
        else
          s = FloatToStrF(double(y2 + h2 - 20 - y) / (h2 - 50) * (Max - Min) + Min, 0, 3, 8);
        c -> TextOut(x2 - c -> TextWidth(s) - data -> Size - 5,
                     y - c -> TextHeight(s) / 2, s);
        if (data -> Ticks)
        {
          c -> MoveTo(x, y);
          c -> LineTo(x + h, y);
        }
      }
      if (data -> Grid && data -> Ticks)
      {
        c -> MoveTo(x + w2, y);
        c -> LineTo(x + h + w2, y);
      }
    }
  }
  if (data -> Grid)
  {
    c -> Pen -> Color = data -> AxesColor;
    c -> Pen -> Width = data -> AxesWidth;
    if (data -> Axes)
    {
      c -> MoveTo(x2, y2);
      c -> LineTo(x2 + w2, y2);
      c -> LineTo(x2 + w2, y2 + h2);
    }
    c -> Pen -> Color = data -> GridColor;
    c -> Pen -> Width = data -> GridWidth;
    for (int i = 0; i < data -> HorzAmount; i++)
    {
      c -> MoveTo(ticks_x[i], y - 2);
      c -> LineTo(ticks_x[i], y2 + (y2 + h2 - y) + 1);
    }
    for (int i = 0; i < data -> VertAmount; i++)
    {
      c -> MoveTo(x + w2 - 2, ticks_y[i]);
      c -> LineTo(x2 + (x2 - x) + 1, ticks_y[i]);
    }
  }
  c -> Pen -> Color = data -> GraphColor;
  c -> Pen -> Width = 2;
  for (int i = 0; i < w2 - a; i++)
  {
    int y;
    if (!data -> Grid)
      y = y2 + h2 - (values[i] - Min) / (Max - Min) * (h2 - 30);
    else
      y = y2 + h2 - 20 - (values[i] - Min) / (Max - Min) * (h2 - 50);
    if (!i)
      c -> MoveTo(x2 + i, y);
    c -> LineTo(x2 + i, y);
  }
  delete values;
  delete ticks_y;
  delete ticks_x;
}

//---------------------------------------------------------------------------
__fastcall TGraphWindow::TGraphWindow(TComponent* Owner)
	: TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TGraphWindow::FormResize(TObject *Sender)
{
  if (ClientWidth < 200) ClientWidth = 200;
  if (ClientHeight < 200) ClientHeight = 200;
  if (prev_data != NULL)
  {
    Redraw(prev_data);
    Invalidate();
  }
}
//---------------------------------------------------------------------------
void __fastcall TGraphWindow::FormPaint(TObject *Sender)
{
  if (prev_data != NULL)
  {
    TRect r;
    r.Left = 0;
    r.Top = 0;
    r.Right = ClientWidth;
    r.Bottom = ClientHeight;
    Canvas -> CopyRect(r, image -> Canvas, r);
  }
}
//---------------------------------------------------------------------------
void __fastcall TGraphWindow::N1Click(TObject *Sender)
{
  SetSizes -> form = this;
  SetSizes -> Edit1 -> Text = FloatToStrF(ClientWidth, 0, 4, 4);
  SetSizes -> Edit2 -> Text = FloatToStrF(ClientHeight, 0, 4, 4);
  SetSizes -> ShowModal();
}
//---------------------------------------------------------------------------
void __fastcall TGraphWindow::N2Click(TObject *Sender)
{
  if (SaveDialog1 -> Execute())
    image -> Picture -> SaveToFile(SaveDialog1 -> FileName);
}
//---------------------------------------------------------------------------
